/* $Id$
 * env_envctrl.h - SUNW,envctrl private definitions
 * Copyright (C) 2004-2005 Eric Brower (ebrower@gmail.com)
 */
 
#ifndef _SPARC64_ENV_ENVCTRL_H
#define _SPARC64_ENV_ENVCTRL_H
 
/* 
 * envctrl definitions 
 */
#define ENV_FSP_LED_ADDR 	0x7C
#define ENV_LED_DISKERR 	(1<<0)
#define ENV_LED_PSERR   	(1<<1)
#define ENV_LED_TEMPERR 	(1<<2)
#define ENV_LED_GENERR  	(1<<3)
#define ENV_LED_ACTIVE  	(1<<4)
#define ENV_LED_POWER   	(1<<5)
#define ENV_FSP_LEDMSK 	        0x3F

#define ENV_FSP_KEY_ON	       0x00
#define ENV_FSP_KEY_DIAG       0x40
#define ENV_FSP_KEY_OFF        0x80
#define ENV_FSP_KEY_LOCK       0xC0
#define ENV_FSP_KEYMSK         0xC0

#define ENV_FSP_CTRL_ADDR      0x70
#define ENV_FSP_DFLOP_INIT0    0x77
#define ENV_FSP_DFLOP_INIT1    0x7F
#define ENV_FSP_DEVINTR_INIT0  0xF7
#define ENV_FSP_DEVINTR_INIT1  0xFF

#define ENV_FAN_SPD_ADDR	0x9C	/* read-only fanspeed interface  */ 
#define ENV_FAN_SPD_SHFT	(2)	/* normalize to 6-bit scale  */ 
#define ENV_FAN_ADDR 		0x4E	/* write-only fanspeed interface */
#define ENV_FAN_PORT_CPU	0x00
#define ENV_FAN_PORT_PS		0x01
#define ENV_FAN_PORT_AFB	0x02
#define ENV_FAN_MAX  		0x3F	/* 6-bit value */

#define ENV_FAN_STAT_ADDR	0x78
#define ENV_FAN_STAT_PS2	(1<<0)
#define ENV_FAN_STAT_PS1	(1<<1)
#define ENV_FAN_STAT_PS0	(1<<2)
#define ENV_FAN_STAT_CPU0	(1<<3) /* enum backwards compared to PSUs? */
#define ENV_FAN_STAT_CPU1	(1<<4)
#define ENV_FAN_STAT_CPU2	(1<<5)
#define ENV_FAN_STAT_PS_MSK	\
	(ENV_FAN_STAT_PS0 | ENV_FAN_STAT_PS1 | ENV_FAN_STAT_PS2)
#define ENV_FAN_STAT_CPU_MSK	\
	(ENV_FAN_STAT_CPU0 | ENV_FAN_STAT_CPU1 | ENV_FAN_STAT_CPU2)
#define ENV_FAN_STAT_PS_SHFT	(0)
#define ENV_FAN_STAT_CPU_SHFT	(3)

#define ENV_FAN_ERR_PS(stat)	\
	(((~stat) & ENV_FAN_STAT_PS_MSK) >> ENV_FAN_STAT_PS_SHFT)
#define ENV_FAN_ERR_CPU(stat)	\
	(((~stat) & ENV_FAN_STAT_CPU_MSK) >> ENV_FAN_STAT_CPU_SHFT)

#define ENV_LM75_ADDR		(0x9A)
/* LM75 initialization - comparator mode, active LO, fault queue depth 2 */
#define ENV_LM75_INIT 		(ENV_LIB_LM75_CFG_FQ2) 

#define ENV_DISK_BP_MAX		3 	/* 3 disk backplanes max. */
#define ENV_DISK_BP_4SLOT	0x0F	/* 4-slot backplane       */
#define ENV_DISK_BP_8SLOT	0xFF	/* 8-slot backplane       */
 
#define ENV_DISK_BP_ADDR_0	(0x40)	/* bottom disk backplane LEDS */
#define ENV_DISK_BP_ADDR_1	(0x42)	/* middle disk backplane LEDS */
#define ENV_DISK_BP_ADDR_2	(0x44)	/* top disk backplane LEDS    */
#define ENV_DISK_MAX      	20 	/* disks 0-19 inclusive */

#define ENV_PS0_ADDR 		0x76
#define ENV_PS1_ADDR 		0x74
#define ENV_PS2_ADDR 		0x72
#define ENV_PS_PRES_MASK	(1<<3)   /* This could also be 1<<0 or 1<<1 */
#define ENV_PS_PRES(stat)	(stat & ENV_PS_PRES_MASK)
#define ENV_PS_MAX		2	/* fans 0-1 inclusive */

#endif /* #ifndef _SPARC64_ENV_ENVCTRL_H */
